// This file was generated by createCFunction.sci on 31-07-2018 01:21

// Computational function for X2C block LookupTable2D

#define SCILAB_SIM_FILE /* mark this file as Scilab simulation file */

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
#include <Simulation_PortConversion.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <LookupTable2D_Float64.h>
#include <LookupTable2D_Float64.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_LookupTable2_Float64_C(scicos_block* block, scicos_flag flag);
static void x2c_LookupTable2_Float64_C__OutputUpdate(scicos_block* block);
static void x2c_LookupTable2_Float64_C__StateUpdate(scicos_block* block);
static void x2c_LookupTable2_Float64_C__Initialization(scicos_block* block);
static void x2c_LookupTable2_Float64_C__Ending(scicos_block* block);


void x2c_LookupTable2_Float64_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_LookupTable2_Float64_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_LookupTable2_Float64_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_LookupTable2_Float64_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_LookupTable2_Float64_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* ContinousPropertiesUpdate (v5.5.x) Jacobian (v5.5.x) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_LookupTable2_Float64_C__set_parameter(scicos_block* block, LOOKUPTABLE2D_FLOAT64 *blockParam) {
    int *paramI;
    double *paramR;
    LOOKUPTABLE2D_FLOAT64 *pTLookupTable2D_Float64;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTLookupTable2D_Float64 = GetWorkPtrs(block);
    blockParam->sfrX = (int8)paramI[0];
    blockParam->sfrY = (int8)paramI[1];
}


static void x2c_LookupTable2_Float64_C__Initialization(scicos_block* block) {
    LOOKUPTABLE2D_FLOAT64 *pTLookupTable2D_Float64;
    int16 arrayStart = 0;

    /* Declaration of inports */
    double *inport_x_p;
    float64 inport_x;
    double *inport_y_p;
    float64 inport_y;

    /* Declaration of outports */
    double *outport_Out;

    /* *** */
    pTLookupTable2D_Float64 = scicos_malloc(sizeof(LOOKUPTABLE2D_FLOAT64) + sizeof(float64)*GetOparSize(block, 1, 2));
    GetWorkPtrs(block) = pTLookupTable2D_Float64;

    /* Initialization of saveable parameter array */
    if (GetNopar(block) < 1) { /* index = 0 requires number >= 1 */
        set_block_error(BLOCK_ERROR_INPUT_OUT_OF_DOMAIN);
    } else if (!((GetOparSize(block, 1, 2) >= 1) & (GetOparSize(block, 1, 1) == 1))) {
        set_block_error(BLOCK_ERROR_INPUT_OUT_OF_DOMAIN);
    } else if (GetOparType(block, 1) == SCSREAL_N) {
        SCSREAL_COP *xcosblock_Opar;  
        int i;
        float64 *ctrl_param;
        ctrl_param = (float64*)(pTLookupTable2D_Float64 + 1 + arrayStart);
        arrayStart = arrayStart + GetOparSize(block, 1, 2);
        xcosblock_Opar = GetRealOparPtrs(block, 1);
        for (i = GetOparSize(block, 1, 2) - 1; i >= 0; i--){
            ctrl_param[i] = (float64)xcosblock_Opar[i];
        }
        pTLookupTable2D_Float64->Table = ctrl_param;
    } else {
        set_block_error(BLOCK_ERROR_INPUT_OUT_OF_DOMAIN);
    }
    x2c_LookupTable2_Float64_C__set_parameter(block, pTLookupTable2D_Float64);

    /* Assignment of inports */
    inport_x_p = GetInPortPtrs(block, 1);
    inport_x = convert_double_to_float64(*inport_x_p);
    pTLookupTable2D_Float64->x = &inport_x;
    inport_y_p = GetInPortPtrs(block, 2);
    inport_y = convert_double_to_float64(*inport_y_p);
    pTLookupTable2D_Float64->y = &inport_y;

    /* Assignment of parameter arrays */
    arrayStart = 0;
    pTLookupTable2D_Float64->Table = pTLookupTable2D_Float64 + 1 + arrayStart;
    arrayStart = arrayStart + GetOparSize(block, 1, 2);

    /* Initialization */
    LookupTable2D_Float64_Init(pTLookupTable2D_Float64);

    /* Assignment of outports */
    outport_Out = GetOutPortPtrs(block, 1);
    *outport_Out = convert_float64_to_double(pTLookupTable2D_Float64->Out);
}


static void x2c_LookupTable2_Float64_C__Ending(scicos_block* block) {
    LOOKUPTABLE2D_FLOAT64 *pTLookupTable2D_Float64;
    pTLookupTable2D_Float64 = GetWorkPtrs(block);
    scicos_free(pTLookupTable2D_Float64);
}


static void x2c_LookupTable2_Float64_C__StateUpdate_f(scicos_block* block) {
/* Do nothing, calling of update function and writing to outputs is done in OutputUpdate */
}


static void x2c_LookupTable2_Float64_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_LookupTable2_Float64_C__StateUpdate_f(block);
    }
}


static void x2c_LookupTable2_Float64_C__OutputUpdate(scicos_block* block) {
    LOOKUPTABLE2D_FLOAT64 *pTLookupTable2D_Float64;
    int16 arrayStart = 0;

    /* Declaration of inports */
    double *inport_x_p;
    float64 inport_x;
    double *inport_y_p;
    float64 inport_y;

    /* Declaration of outports */
    double *outport_Out;

    /* *** */
    pTLookupTable2D_Float64 = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_x_p = GetInPortPtrs(block, 1);
    inport_x = convert_double_to_float64(*inport_x_p);
    pTLookupTable2D_Float64->x = &inport_x;
    inport_y_p = GetInPortPtrs(block, 2);
    inport_y = convert_double_to_float64(*inport_y_p);
    pTLookupTable2D_Float64->y = &inport_y;

    /* Assignment of parameter arrays */
    pTLookupTable2D_Float64->Table = pTLookupTable2D_Float64 + 1 + arrayStart;
    arrayStart = arrayStart + GetOparSize(block, 1, 2);

    /* Update */
    LookupTable2D_Float64_Update(pTLookupTable2D_Float64);

    /* Assignment of outports */
    outport_Out = GetOutPortPtrs(block, 1);
    *outport_Out = convert_float64_to_double(pTLookupTable2D_Float64->Out);
}


